/*
* HMG Grid Demo
* (c) 2005 Roberto Lopez
*/

#include "hmg.ch"
#define MY_RED          { 255, 091, 091 }

#define LVIS_FOCUSED                   0x1
#define LVIS_SELECTED                  0x2

MEMVAR _HMG_SYSDATA
MEMVAR bckColor,bckFore,aItems

Function Main
PRIVATE bckColor :=  WHITE
PRIVATE bckFore  :=  BLACK
PRIVATE aItems   := {}

      AADD (aItems, {"Carrot"     , 1 })
      AADD (aItems, {"Cauliflower", 1 })
      AADD (aItems, {"Corn"       , 1 })
      AADD (aItems, {"Tomato"     , 1 })
      AADD (aItems, {"Zucchini"   , 1 })

   DEFINE WINDOW Form_1 ;
      AT 0,0 ;
      WIDTH 640 ;
      HEIGHT 400 ;
      TITLE 'Spinner Grid Test' ;
      MAIN ;
      ON INIT (Form_1.CENTER , Actualiza() , Form_1.nTotalArt.setfocus )

   DEFINE TEXTBOX nTotalArt
        ROW      220
        COL      240
        WIDTH     60
        HEIGHT    40
        FONTNAME "Arial"
        FONTSIZE 14
        TOOLTIP  "Total "
        ONCHANGE         Nil
        ONGOTFOCUS       Nil
        ONLOSTFOCUS      Nil
        FONTBOLD         .T.
        FONTITALIC       .F.
        FONTUNDERLINE    .F.
        FONTSTRIKEOUT    .F.
        ONENTER           Nil
        HELPID            Nil
        TABSTOP           .T.
        VISIBLE           .T.
        READONLY          .F.
        RIGHTALIGN        .T.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        CASECONVERT       NONE
        BACKCOLOR         NIL
        FONTCOLOR        {255,0,0}
        INPUTMASK        Nil
        FORMAT            Nil
        NUMERIC          .T.
        VALUE             0
    END TEXTBOX

   DEFINE LABEL Label_1
        ROW         230
        COL         150
        WIDTH       100
        HEIGHT      95
        VALUE       "Total :"
        FONTNAME    "Arial"
        FONTSIZE    18
        TOOLTIP     "Total"
        VISIBLE     .T.
    END LABEL

      DEFINE GRID  Grid_1
      ROW      5
      COL      5
      WIDTH  620
      HEIGHT 200
      VALUE    1
      HEADERS {'vegetables' , 'quantity ' }
      WIDTHS  {160          , 140       }
      FONTNAME "Segoe UI"
      FONTSIZE 12
      JUSTIFY { GRID_JTFY_RIGHT, GRID_JTFY_RIGHT  }
      ITEMS   aItems
      COLUMNCONTROLS   { {'TEXTBOX','CHARACTER' }, {'SPINNER'  , 1  , 24 } }
      COLUMNWHEN       { {|| .f. }               , {|| .t. } }
      COLUMNVALID      {  Nil                    , {|| if ( This.CellValue > 1 ,  Actualiza1() , nil ) } }
      DYNAMICBACKCOLOR {  bckColor               , {|| If( ValorCelda2( 2 ) > 1, MY_RED , WHITE )      } }
      DYNAMICFORECOLOR {  bckFore                , {|| If( ValorCelda2( 2 ) > 1, WHITE  , BLACK )      } }
      ONGOTFOCUS nil   //      Form_1.nTotalArt.SetFocus
      ONCHANGE Actualiza()
      SHOWHEADERS    .T.
      ALLOWEDIT      .T.
      CELLNAVIGATION .F.
      ITEMCOUNT       5
    END GRID

   END WINDOW

   CENTER WINDOW Form_1

   ACTIVATE WINDOW Form_1

Return nil

*----------------------------------------------------------------------------*
Procedure Actualiza()
*----------------------------------------------------------------------------*
*Local aItem := {}
Local nValue
LOCAL nItems, nFor
LOCAL nCol := 2

   nItems := Form_1.Grid_1.Value
   Form_1.nTotalArt.Value   := 0

   For nFor := 1 to Form_1.Grid_1.ItemCount
       *aItem := Form_1.Grid_1.item (nFor )
       *Form_1.nTotalArt.Value := Form_1.nTotalArt.Value + aItem[2]

      nValue := GetProperty( "Form_1", "Grid_1", "CellEX", nFor, nCol)
      Form_1.nTotalArt.Value := Form_1.nTotalArt.Value + nValue
   Next
*  Form_1.Grid_1.Refresh
   Form_1.nTotalArt.SetFocus
RETURN

Procedure Actualiza1()
Local nItem     := Form_1.Grid_1.Value
Local aProducto := Form_1.Grid_1.item ( nItem )
Local nValue    := This.CellValue
LOCAL hGrid := GetControlHandle("Grid_1", "Form_1" )

   aProducto[2]                   := nValue
   Form_1.Grid_1.item ( nItem )   := aProducto

   // de-lite Item
   LISTVIEW_SETITEMSTATE( hGrid, nItem, 0, hb_BitOr( LVIS_SELECTED, LVIS_FOCUSED ) )

   Actualiza()

RETURN

Function ValorCelda2( nCol )
Local nRow := This.CellRowIndex
Local nRet := GetProperty( "Form_1", "Grid_1", "CellEX", nRow, nCol)
Return nRet

*
*
*